<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Official Perl 6 Documentation</title>
<link rel="stylesheet" href="http://dev.perl.org/css/perl.css" type="text/css" />
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<link rev="made" href="mailto:" />
<script language="javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.4.2/jquery.min.js"></script>
<script language="javascript">
<!--
$(document).ready(function() {
    $('#intro-text').toggle();
    $('#read-more').click(function() {
        $('#intro-text').toggle();
    });
});
// --></script>

</head>

<body style="margin-left: 0.3in">

<table border="0" cellspacing="0" cellpadding="0" width="100%">
<tr>
<td align="right">
<form method="get" action="http://www.google.com/search" style="position: absolute; top: 5px; right: 5px; text-align: right; "><div>
<input type="hidden" name="ie" value="UTF-8" />
<input type="hidden" name="oe" value="UTF-8" />
<input type="hidden" name="domains" value="perlcabal.org" />
<input type="hidden" name="sitesearch" value="perlcabal.org/syn/" />
<input type="text" name="q" size="31" maxlength="255" value="" /> 
<input type="submit" name="btnG" value="Google Search the Synopses" />
</div></form>
</td>
</tr>
</table>


<h2><a name="Feather">Official Perl 6 Documentation</a></h2>

<p><b>The Synopsis documents are to be taken as the formal 
specification for Perl 6 implementations</b>, while still 
being reference documentation for Perl 6, like 
<i>Programming Perl</i> is for Perl 5. Note that while 
these documents are considered ``formal
specifications'', they are still being subjected to the
rigors of cross-examination through implementation.
In other words, they may change slightly or radically. 
But the expectation is that they are ``very close'' to 
the final shape of Perl 6.
<a href="#" id="read-more">[Read more...]</a></p>

<div id="intro-text">
<p>However, this HTML version of Synopses is slightly
different in that it contains code snippets from
the Pugs test suite. In other words, We have divided the .t files in the
test suite into pieces and inserted every resulting 
snippet after the corresponding paragraph of the Synopses.
Furthermore, the embedded tests are also marked by <code>√</code> and <code>×</code>
according to the results of daily auto-smoking on feather.
The job is done by the Perl 5 script util/smartlinks.pl
living in the Pugs source tree.</p>

<p>All the web pages for Synopses listed
below are updated every <i>one</i> hour from the Pugs SVN repository
with the latest Synopses and Pugs test suite.  </p>

<p>When we say ``S05'', we mean ``spec'' as well as ``synopsis''.</p>

<p>Note that documents marked DRAFT are really just that.  They are often
written by random people, and have not been approved of as part of the 
official spec.  </p>

<p>The documents here mostly correspond with the chapters in the Camel Book, 
that is, &quot;Programming Perl, 3rd Edition&quot;.  However, a few chapters
of that book will no longer be relevant, and those numbers will be resused 
for other things.  At the moment, this refers to section 7, whose synopsis is
"Iterators", but whose Exegesis is about the module Form.pm.  Apocalypses and
Exegeses were only written for some of the early sections; the later sections
have no corresponding apocalypse/exegesis.  </p>

<p>Most changes to these specifications have been discussed on the 
<a href="http://dev.perl.org/perl6/lists/">perl6-language mailing list</a> or the
<code>#perl6</code> FreeNode channel on IRC.
Additionally, Larry Wall has created an implementation of the parser 
for Perl 6 (but it doesn't do any of the backend stuff), and that is usually
regarded as authoritative.  </p>
</div>

<p><em>While the Apocalypses and Exegeses are linked here for reference, note
that they are historical documents, whereas the Synopses are kept more 
up-to-date and are the primary recommended reference.</em></p>

<table id="doctable">
    <tr>
        <th></th>
        <th></th>
        <th><strong>(Specification)</strong>
		&nbsp; &nbsp; &nbsp; &nbsp;</th>
	<th>(Syn pod)</th>
        <th>(Justification)</th>
        <th>(Explanation)</th>
    </tr>
    <tr>
        <td>1</td>
        <td>Overview</td>
        <td><a href="S01.html"><strong>Synopsis</strong></a></td>
	<td><a href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S01-overview.pod">S01-overview.pod</a></td>
        <td><a href="http://dev.perl.org/perl6/doc/design/apo/A01.html">Apocalypse</a></td>
    </tr>
    <tr>
        <td>2</td>
        <td>Bits and Pieces</td>
        <td><a href="S02.html"><strong>Synopsis</strong></a></td>
	<td><a href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S02-bits.pod">S02-bits.pod</a></td>
        <td><a href="http://dev.perl.org/perl6/doc/design/apo/A02.html">Apocalypse</a></td>
        <td><a href="http://dev.perl.org/perl6/doc/design/exe/E02.html">Exegesis</a></td>
    </tr>
    <tr>
        <td>3</td>
        <td>Summary&nbsp;of&nbsp;Perl&nbsp;6&nbsp;Operators&nbsp;&nbsp;&nbsp;&nbsp;</td>
        <td><a href="S03.html"><strong>Synopsis</strong></a></td>
	<td><a href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S03-operators.pod">S03-operator.pod</a></td>
        <td><a href="http://dev.perl.org/perl6/doc/design/apo/A03.html">Apocalypse</a></td>
        <td><a href="http://dev.perl.org/perl6/doc/design/exe/E03.html">Exegesis</a></td>
    </tr>
    <tr>
        <td>4</td>
        <td>Blocks and Statements</td>
        <td><a href="S04.html"><strong>Synopsis</strong></a></td>
	<td><a href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S04-control.pod">S04-control.pod</a></td>
        <td><a href="http://dev.perl.org/perl6/doc/design/apo/A04.html">Apocalypse</a></td>
        <td><a href="http://dev.perl.org/perl6/doc/design/exe/E04.html">Exegesis</a></td>
    </tr>
    <tr>
        <td>5</td>
        <td>Regexes and Rules</td>
        <td><a href="S05.html"><strong>Synopsis</strong></a></td>
	<td><a href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S05-regex.pod">S05-regex.pod</a></td>
        <td><a href="http://dev.perl.org/perl6/doc/design/apo/A05.html">Apocalypse</a></td>
        <td><a href="http://dev.perl.org/perl6/doc/design/exe/E05.html">Exegesis</a></td>
    </tr>
    <tr>
        <td>6</td>
        <td>Subroutines</td>
        <td><a href="S06.html"><strong>Synopsis</strong></a></td>
	<td><a href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S06-routines.pod">S06-subroutines.pod</a></td>
        <td><a href="http://dev.perl.org/perl6/doc/design/apo/A06.html">Apocalypse</a></td>
        <td><a href="http://dev.perl.org/perl6/doc/design/exe/E06.html">Exegesis</a></td>
    </tr>
    <tr>
        <td>7</td>
        <td>Iterators [DRAFT]</td>
        <td><a href="S07.html"><strong>Synopsis</strong></td>
	<td><a
    href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S07-iterators.pod">S07-iterators.pod</td>
        <td></td>
        <td></td>
    </tr>
    <tr>
        <td>8</td>
        <td>Captures and Parcels [DRAFT]</td>
        <td><a href="S08.html"><strong>Synopsis</strong></td>
	<td><a
    href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S08-capture.pod">S08-capture.pod</td>
        <td></td>
        <td></td>
    </tr>
    <tr>
        <td>9</td>
        <td>Data Structures</td>
        <td><a href="S09.html"><strong>Synopsis</strong></a></td>
	<td><a href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S09-data.pod">S09-data.pod</a></td>
        <td></td>
        <td></td>
    </tr>
    <tr>
        <td>10</td>
        <td>Packages</td>
        <td><a href="S10.html"><strong>Synopsis</strong></a></td>
	<td><a href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S10-packages.pod">S10-packages.pod</a></td>
        <td></td>
        <td></td>
    </tr>
    <tr>
        <td>11</td>
        <td>Modules</td>
        <td><a href="S11.html"><strong>Synopsis</strong></a></td>
	<td><a href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S11-modules.pod">S11-modules.pod</a></td>
        <td></td>
        <td></td>
    </tr>
    <tr>
        <td>12</td>
        <td>Objects</td>
        <td><a href="S12.html"><strong>Synopsis</strong></a></td>
	<td><a
    href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S12-objects.pod">S12-objects.pod</a></td>
        <td><a href="http://dev.perl.org/perl6/doc/design/apo/A12.html">Apocalypse</a></td>
        <td></td>
    </tr>
    <tr>
        <td>13</td>
        <td>Overloading</td>
        <td><a href="S13.html"><strong>Synopsis</strong></a></td>
	<td><a
    href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S13-overloading.pod">S13-overloading.pod</a></td>
        <td></td>
        <td></td>
    </tr>
    <tr>
        <td>14</td>
        <td>Roles&nbsp;and&nbsp;Parametric&nbsp;Types&nbsp;[DRAFT]</td>
        <td><a href="S14.html"><strong>Synopsis</strong></a></td>
	<td><a
    href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S14-roles-and-parametric-types.pod">S14-roles-and-parametric-types.pod</a></td>
        <td></td>
        <td></td>
    </tr>
    <tr><td>15</td><td>Unicode</td><td colspan="4">(TBD)</td></tr>
    <tr>
        <td>16</td>
        <td>IO&nbsp;/&nbsp;User&nbsp;/&nbsp;Group&nbsp;[DRAFT]</td>
        <td><a href="S16.html"><strong>Synopsis</strong></a></td>
	<td><a href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S16-io.pod">S16-io.pod</a></td>
        <td></td>
        <td></td>
    </tr>
    <tr>
        <td>17</td>
	<td>Processes&nbsp;and&nbsp;Concurrency&nbsp;[DRAFT]</td>
    <td><a href="S17.html"><strong>Synopsis</strong></a></td>
	<td><a href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S17-concurrency.pod">S17-concurrency.pod</a></td>
        <td></td>
	<td></td>
    </tr>
    <tr><td>18</td><td>Compiling</td><td colspan="4">(TBD)</td></tr>
    <tr>
        <td>19</td><td>Command line interface [DRAFT]</td>
        <td><a href="S19.html"><strong>Synopsis</strong></a></td>
        <td><a href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S19-commandline.pod">S19-commandline.pod</a></td>
        <td></td>
        <td></td>
    </tr>
    <tr><td>20</td><td>Introspection</td><td colspan="4">(Draft)</td></td></tr>
    <tr>
        <td>21</td>
        <td>Calling foreign code&nbsp;[DRAFT]</td>
    <td><a href="S21.html"><strong>Synopsis</strong></a></td>
	<td><a href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S21-calling-foreign-code.pod">S21-calling-foreign-code.pod</a></td>
	<td></td>
	<td></td>
    </tr>
    <tr>
        <td>22</td>
	<td>CPAN&nbsp;[DRAFT]</td>
    <td><a href="S22.html"><strong>Synopsis</strong></a></td>
	<td><a href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S22-cpan.pod">S22-cpan.pod</a></td>
	<td></td>
	<td></td>
    </tr>
    <tr><td>23</td><td>Security</td><td colspan="4">(TBD)</td></tr>
    <tr><td>24</td><td>Testing</td><td colspan="4">(TBD)</td></tr>
    <tr><td>25</td><td>Portable perl</td><td colspan="4">(TBD)</td></tr>
    <tr>
        <td>26</td>
        <td>Documentation</td>
        <td><strong>Synopsis</strong></td>
	<td><a href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S26-documentation.pod">S26-documentation.pod</a></td>
        <td></td>
        <td></td>
    </tr>
    <tr><td>27</td><td>Perl culture</td><td colspan="4">(Draft)</td></tr>
    <tr>
        <td>28</td>
        <td>Special names</td>
        <td><a href="S28.html"><strong>Synopsis</strong></a></td>
	<td><a href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S28-special-names.pod">S28-special-names.pod</a></td>
        <td></td>
        <td></td>
    </tr>
    <tr>
        <td>29</td>
        <td>Builtin Functions&nbsp;[DRAFT]</td>
        <td><a href="S29.html"><strong>Synopsis</strong></a></td>
	<td><a href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S29-functions.pod">S29-functions.pod</a></td>
        <td></td>
        <td></td>
    </tr>
    <tr><td>30</td><td>Standard perl library</td><td colspan="4">(TBD)</td></tr>
    <tr>
        <td>31</td>
        <td>Pragmatic modules [DRAFT]</td>
        <td><a href="S31.html"><strong>Synopsis</strong></a></td>
	<td><a href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S31-pragmatic-modules.pod">S31-pragmatic-modules.pod</a></td>
	<td></td>
	<td></td>
    </tr>
    <tr><td>32</td><td>Setting library [DRAFT]</td><td colspan="4">&nbsp;</td></tr>
    <tr>
        <td></td>
        <td>Abstraction* &nbsp;[DRAFT]</td>
        <td><a href="S32/Abstraction.html"><strong>Synopsis</strong></a></td>
	<td><a href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S32-setting-library/Abstraction.pod">Abstraction.pod</a></td>
	<td></td>
	<td></td>
    </tr>
    <tr>
        <td></td>
        <td>Basics+&nbsp;[DRAFT]</td>
        <td><a href="S32/Basics.html"><strong>Synopsis</strong></a></td>
	<td><a href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S32-setting-library/Basics.pod">Basics.pod</a></td>
	<td></td>
	<td></td>
    </tr>
    <tr>
        <td></td>
        <td>Callable*&nbsp;[DRAFT]</td>
        <td><a href="S32/Callable.html"><strong>Synopsis</strong></a></td>
	<td><a href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S32-setting-library/Callable.pod">Callable.pod</a></td>
	<td></td>
	<td></td>
    </tr>
    <tr>
        <td></td>
        <td>Containers*&nbsp;[DRAFT]</td>
        <td><a href="S32/Containers.html"><strong>Synopsis</strong></a></td>
	<td><a href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S32-setting-library/Containers.pod">Containers.pod</a></td>
	<td></td>
	<td></td>
    </tr>
    <tr>
        <td></td>
        <td>Exception*&nbsp;[DRAFT]</td>
        <td><a href="S32/Exception.html"><strong>Synopsis</strong></a></td>
	<td><a href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S32-setting-library/Exception.pod">Exception.pod</a></td>
	<td></td>
	<td></td>
    </tr>
    <tr>
        <td></td>
        <td>IO*&nbsp;[DRAFT]</td>
        <td><a href="S32/IO.html"><strong>Synopsis</strong></a></td>
	<td><a href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S32-setting-library/IO.pod">IO.pod</a></td>
	<td></td>
	<td></td>
    </tr>
    <tr>
        <td></td>
        <td>Numeric*&nbsp;[DRAFT]</td>
        <td><a href="S32/Numeric.html"><strong>Synopsis</strong></a></td>
	<td><a href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S32-setting-library/Numeric.pod">Numeric.pod</a></td>
	<td></td>
	<td></td>
    </tr>
    <tr>
        <td></td>
        <td>Rules*&nbsp;[DRAFT]</td>
        <td><a href="S32/Rules.html"><strong>Synopsis</strong></a></td>
	<td><a href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S32-setting-library/Rules.pod">Rules.pod</a></td>
	<td></td>
	<td></td>
    </tr>
    <tr>
        <td></td>
        <td>Str&nbsp;[DRAFT]</td>
        <td><a href="S32/Str.html"><strong>Synopsis</strong></a></td>
	<td><a href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S32-setting-library/Str.pod">Str.pod</a></td>
	<td></td>
	<td></td>
    </tr>
    <tr>
        <td></td>
        <td>Temporal*&nbsp;[DRAFT]</td>
        <td><a href="S32/Temporal.html"><strong>Synopsis</strong></a></td>
	<td><a href="http://svn.pugscode.org/pugs/docs/Perl6/Spec/S32-setting-library/Temporal.pod">Temporal.pod</a></td>
	<td></td>
	<td></td>
    </tr>
    <tr><td>33</td><td>Diagnostic messages</td><td colspan="4">(TBD)</td></tr>
</table>

<h3>Indexes</h3>
<a href="index_X.html">X tags</a><br />
<a href="index_C.html">C tags</a><br />

<h3>S32 Key</h3>

<dl>
  <dt>* = Document related types as well</dt>
  <dt>+ = Not a type name, but documents a group of types</dt>
</dl>

<h2>DRAFT specifications</h2>
<p>
The few draft PODs here should probably be cleaned up into Spec-like
formats and moved to Perl6::Spec space.
</p>
<ul>
 <li><a href="http://svn.pugscode.org/pugs/docs/AES/A20draft.pod">Debugging</a></li>
 <li><a href="http://svn.pugscode.org/pugs/docs/AES/S27draft.pod">Perl Culture</a></li>
</ul>

<h2>Frequently Asked Questions</h2>

<!-- please convert these to HTML and link to those versions -->
<ul>
    <li><a href="http://dev.perl.org/perl6/faq.html">General Questions about Perl6</a></li>
    <li><a href="http://svn.pugscode.org/pugs/docs/01Overview.html">Pugs FAQ</a></li>
    <li><a href="http://svn.pugscode.org/pugs/docs/Perl6/FAQ/FUD.pod">Fears, Uncertainties and Doubts about Perl6</a></li>
    <li><a href="http://svn.pugscode.org/pugs/docs/Perl6/FAQ/Capture.pod">Capture Objects</a></li>
</ul>

<h2>Differences from Perl 5</h2>

<ul>
    <li><a href="Differences.html">Differences Between Perl 5 and Perl 6</a></li>
</ul>

<p>
The Differences document is stored in <code>docs/Perl6/Perl5/Differences.pod</code>
in the pugs repository, if you'd like to make updates to it. Your changes will 
automatically appear on feather in less than 1 hour.
</p>

<h2>Perl6 Cookbooks</h2>

<ul>
    <li><a href="http://svn.pugscode.org/pugs/examples/cookbook/">Perl6 Cookbook</a> 
    Currently a work in progress, this cookbook is part of the 
            <a href="http://pleac.sourceforge.net/">PLEAC</a> project,
    following the example of the Perl 5 cookbook.
    
    </li>
    <li><a href="http://cog.cognitivity.com/perl6/">Perl6 OO Cookbook</a> <em>(parts may not be current)</em></li>
</ul>

<h2>Example Code</h2>
<p>
Many more examples of Perl6 code are available.
</p>
<ul>
    <li><a href="http://svn.pugscode.org/pugs/examples/">Examples of Perl6 from the Pugs repository</a></li>
    <li><a href="http://svn.pugscode.org/pugs/ext/">Complete distributions from the Pugs repository</a></li>
</ul>





<h2>About this page</h2>

<p>
The page you're currently looking at lives in the Pugs repo as 
<code>docs/feather/syn_index.html</code>, and is resync'd every 1 hour.
</p>

</body>

</html>
